level-0 6.3 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196
  1. #!/bin/sh
  2. #
  3. # Run this script as root on the machine that has the tape drive, to make a
  4. # full (level-0) dump.
  5. #
  6. # If you give `now' as an argument, the dump is done immediately.
  7. # Otherwise, it waits until 1am, or until the hour given as argument.
  8. # Specify the hour as a number from 0 to 23.
  9. #
  10. # You must edit the file `backup-specs' to set the parameters for your site.
  11. # Useful for backup-specs, in case things have to be done slightly
  12. # differently for different dump levels.
  13. DUMP_LEVEL=0
  14. # Insure `mail' is in PATH.
  15. PATH="/usr/ucb:${PATH}"
  16. export PATH
  17. # This is not the most reliable test in the world. The following might be
  18. # more predictable:
  19. #
  20. # whoami="`whoami`"
  21. # euid="`sed -ne '/^'\"${whoami}\"':/{s/^[^:]*:[^:]*://;s/:.*//p;q;}' /etc/passwd`"
  22. # if [ "${euid}" != 0 ]; then ...
  23. #
  24. if [ ! -w / ]; then
  25. echo "The backup must be run as root or else some files will fail to be dumped."
  26. exit 1
  27. fi
  28. # Get the values of BACKUP_DIRS, BACKUP_FILES, and other variables.
  29. . ./backup-specs
  30. # Maybe sleep until around specified or default hour.
  31. if [ "${1}" != "now" ]; then
  32. if [ "${1}x" != "x" ]; then
  33. spec="${1}"
  34. else
  35. spec="${BACKUP_HOUR}"
  36. fi
  37. pausetime="`date | awk '
  38. {
  39. hr = substr($4, 1, 2);
  40. mn = substr($4, 4, 2);
  41. if((hr + 0) < (spec + 0))
  42. print 3600 * (spec - hr) - 60 * mn;
  43. else
  44. print 3600 * (spec + (24 - hr)) - 60 * mn;
  45. }' spec=\"${spec}\"`"
  46. clear
  47. echo "${SLEEP_MESSAGE}"
  48. sleep "${pausetime}"
  49. fi
  50. # start doing things
  51. # Put startdate in the subject line of mailed report, since if it happens
  52. # to run longer than 24 hours (as may be the case if someone forgets to put
  53. # in the next volume of the tape in adequate time), the backup date won't
  54. # appear too misleading.
  55. startdate="`date`"
  56. here="`pwd`"
  57. # Logfile name should be in the form ``log-1993-03-18-level-0''
  58. # i.e. year-month-date. This format is useful for sorting by name, since
  59. # logfiles are intentionally kept online for future reference.
  60. LOGFILE=log-`date | awk '
  61. BEGIN {
  62. d["Jan"] = "01"; d["Feb"] = "02"; d["Mar"] = "03";
  63. d["Apr"] = "04"; d["May"] = "05"; d["Jun"] = "06";
  64. d["Jul"] = "07"; d["Aug"] = "08"; d["Sep"] = "09";
  65. d["Oct"] = "10"; d["Nov"] = "11"; d["Dec"] = "12";
  66. }
  67. {
  68. if ($3 < 10)
  69. $3 = "0" $3;
  70. print $6 "-" d[$2] "-" $3;
  71. }'`-level-${DUMP_LEVEL}
  72. localhost="`hostname | sed -e 's/\..*//'`"
  73. TAR_PART1="/usr/local/bin/tar -c --multi-volume --one-file-system --block=${BLOCKING} --sparse --volno-file=${VOLNO_FILE}"
  74. # Only use --info-script if DUMP_REMIND_SCRIPT was defined in backup-specs
  75. if [ "x${DUMP_REMIND_SCRIPT}" != "x" ]; then
  76. TAR_PART1="${TAR_PART1} --info-script='${DUMP_REMIND_SCRIPT}'"
  77. fi
  78. # Make sure the log file did not already exist. Create it.
  79. if [ -f "${LOGFILE}" ] ; then
  80. echo "Log file ${LOGFILE} already exists." 1>&2
  81. exit 1
  82. else
  83. touch "${LOGFILE}"
  84. fi
  85. # Most everything below here is run in a subshell for which all output is
  86. # piped through `tee' to the logfile. Doing this, instead of having
  87. # multiple pipelines all over the place, is cleaner and allows access to
  88. # the exit value from various commands more easily.
  89. (
  90. # Caveat: Some version of `mt' require `-t', not `-f'.
  91. mt -f "${TAPE_FILE}" rewind
  92. rm -f "${VOLNO_FILE}"
  93. set - "${BACKUP_DIRS}"
  94. while [ $# -ne 0 ] ; do
  95. date="`date`"
  96. remotehost="`echo \"${1}\" | sed -e 's/:.*$//'`"
  97. fs="`echo \"${1}\" | sed -e 's/^.*://'`"
  98. fsname="`echo \"${1}\" | sed -e 's/\//:/g'`"
  99. # This filename must be absolute; it is opened on the machine that runs tar.
  100. TAR_PART2="--listed=/etc/tar-backup/temp.level-0"
  101. TAR_PART3="--label='Full backup of ${fs} on ${remotehost} at ${date}' -C ${fs} ."
  102. echo "Backing up ${1} at ${date}"
  103. # Actually back things up.
  104. if [ "z${localhost}" != "z${remotehost}" ] ; then
  105. rsh "${remotehost}" mkdir /etc/tar-backup > /dev/null 2>&1
  106. rsh "${remotehost}" rm -f /etc/tar-backup/temp.level-0
  107. rsh "${remotehost}" ${TAR_PART1} -f "${localhost}:${TAPE_FILE}" ${TAR_PART2} ${TAR_PART3}
  108. else
  109. mkdir /etc/tar-backup > /dev/null 2>&1
  110. rm -f /etc/tar-backup/temp.level-0
  111. # Using `sh -c exec' causes nested quoting and shell substitution
  112. # to be handled here in the same way rsh handles it.
  113. sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3}"
  114. fi
  115. # `rsh' doesn't exit with the exit status of the remote command. What
  116. # stupid lossage. TODO: think of a reliable workaround.
  117. if [ $? -ne 0 ] ; then
  118. echo "Backup of ${1} failed." 1>&2
  119. # I'm assuming that the tar will have written an empty
  120. # file to the tape, otherwise I should do a cat here.
  121. else
  122. if [ "z${localhost}" != "z${remotehost}" ] ; then
  123. rsh "${remotehost}" mv -f /etc/tar-backup/temp.level-0 "/etc/tar-backup/${fsname}.level-0"
  124. else
  125. mv -f /etc/tar-backup/temp.level-0 "/etc/tar-backup/${fsname}.level-0"
  126. fi
  127. fi
  128. ${TAPE_STATUS}
  129. sleep 60
  130. shift
  131. done
  132. # Dump any individual files requested.
  133. if [ "x${BACKUP_FILES}" != "x" ] ; then
  134. date="`date`"
  135. TAR_PART2="--listed=/etc/tar-backup/temp.level-0"
  136. TAR_PART3="--label='Full backup of miscellaneous files at ${date}'"
  137. mkdir /etc/tar-backup > /dev/null 2>&1
  138. rm -f /etc/tar-backup/temp.level-0
  139. echo "Backing up miscellaneous files at ${date}"
  140. # Using `sh -c exec' causes nested quoting and shell substitution
  141. # to be handled here in the same way rsh handles it.
  142. sh -c "exec ${TAR_PART1} -f \"${TAPE_FILE}\" ${TAR_PART2} ${TAR_PART3} ${BACKUP_FILES}"
  143. # `rsh' doesn't exit with the exit status of the remote command. What
  144. # lossage. TODO: think of a reliable workaround.
  145. if [ $? -ne 0 ] ; then
  146. echo "Backup of miscellaneous files failed."
  147. # I'm assuming that the tar will have written an empty
  148. # file to the tape, otherwise I should do a cat here.
  149. else
  150. mv -f /etc/tar-backup/temp.level-0 /etc/tar-backup/misc.level-0
  151. fi
  152. ${TAPE_STATUS}
  153. else
  154. echo "No miscellaneous files specified"
  155. fi
  156. # Caveat: some versions of `mt' use `-t' instead of `-f'.
  157. mt -f "${TAPE_FILE}" rewind
  158. mt -f "${TAPE_FILE}" offl
  159. ) 2>&1 | tee -a "${LOGFILE}"
  160. echo "Sending the dump log to ${ADMINISTRATOR}"
  161. mail -s "Results of backup started ${startdate}" ${ADMINISTRATOR} < "${LOGFILE}"
  162. # eof